<?php
/*
 * @author      Luxiaoping 2013.02.05
 * @package     task
 * @version     v1.0
 * 
 * 覆盖task/control.php的export方法
 * 将任务列表导出到excel
 * 
 * 引入PHPExcel插件，放在task/ext文件夹下了，其他模块均可调用
 */

include '../../control.php';
class mytask extends task
{
    public function export($projectID, $orderBy)
    {    	
        if($_POST)
        {
        	/** Error reporting */
			error_reporting(E_ALL);
			ini_set('display_errors', false);
			ini_set('display_startup_errors', false);
			
			if (PHP_SAPI == 'cli')
				die('This example should only be run from a Web Browser');
									
			/** Include PHPExcel */
			require_once '../PHPExcel/Classes/PHPExcel.php';			
			
			// Create new PHPExcel object
			$objPHPExcel = new PHPExcel();
			
			// Miscellaneous glyphs, UTF-8
			$objActiveSheet = $objPHPExcel->setActiveSheetIndex(0);
			
			/*****************filling the excel*******************/	
			$taskLang   = $this->lang->task;
            $taskConfig = $this->config->task;
            
            /* Get users and projects. */
            $users    = $this->loadModel('user')->getPairs('noletter');
            $projects = $this->loadModel('project')->getPairs('all');

			/** process post data */
			$starttime = $this->post->starttime;
			$endtime = $this->post->endtime;
			$timespan = '"' . $starttime . '" and "' . $endtime . ' 23:59:59"';
			$andwhere = ' and (t1.realStarted between ' . $timespan . ' or finishedDate between ' . $timespan . ')';
			
			$exportUser = "所有人";      //导出对象，用于合成默认文件名
			if($this->post->user != '0')    //所有人 对应键值为0 
			{
				$exportUser = $users[$this->post->user];				
				//未完成的任务，‘完成者’为空，应按‘指派给’来识别
				$andwhere .= ' and (t1.finishedBy = "' . $this->post->user . '" or t1.assignedTo = "' . $this->post->user . '")';				
			}
			$filename = $exportUser . $starttime . '至' . $endtime;
			
            /* Create field lists. */
            $fields = $this->post->exportFields;
            
            /* fill titles. */
            $col = 0;         //记录列名的最大值，用于填充评价列
            $maxSels = 3;     //最大评价维度数
            foreach($fields as $key => $fieldName)
            {
                $fieldName = trim($fieldName);
                $fields[$fieldName] = isset($taskLang->$fieldName) ? $taskLang->$fieldName : $fieldName;
                $objActiveSheet->setCellValueByColumnAndRow ($key,1,$fields[$fieldName]);
	        	unset($fields[$key]);
	        	$col = $key;
            }
            for ($i = 1; $i <= $maxSels; $i++)      //增加评价列
            { 
                $objActiveSheet->setCellValueByColumnAndRow ($col + $i,1,'评价维度'.$i);          	
            }
         
            /* Get tasks. */ 
            $tasks = $this->dao->select('t1.*,t2.comment')
	            ->from(TABLE_TASK)->alias('t1')
	            ->leftJoin(TABLE_ACTION)->alias('t2')
	            ->on('t1.id = t2.objectID')
	            ->where('t2.objectType = "task"' . $andwhere)	            
	            ->orderBy('project')
	            ->fetchAll('id');             
				
            foreach($tasks as $task)
            {
                if(isset($projects[$task->project]))                  $task->project      = $projects[$task->project];
                if(isset($taskLang->typeList[$task->type]))           $task->type         = $taskLang->typeList[$task->type];
                if(isset($taskLang->priList[$task->pri]))             $task->pri          = $taskLang->priList[$task->pri];
                if(isset($taskLang->statusList[$task->status]))       $task->status       = $taskLang->statusList[$task->status];
                if(isset($taskLang->reasonList[$task->closedReason])) $task->closedReason = $taskLang->reasonList[$task->closedReason];

                if(isset($users[$task->openedBy]))     $task->openedBy     = $users[$task->openedBy];
                if(isset($users[$task->assignedTo]))   $task->assignedTo   = $users[$task->assignedTo];
                if(isset($users[$task->finishedBy]))   $task->finishedBy   = $users[$task->finishedBy];
                if(isset($users[$task->canceledBy]))   $task->canceledBy   = $users[$task->canceledBy];
                if(isset($users[$task->closedBy]))     $task->closedBy     = $users[$task->closedBy];
                if(isset($users[$task->lastEditedBy])) $task->lastEditedBy = $users[$task->lastEditedBy];

                $task->openedDate     = substr($task->openedDate,     0, 10);
                $task->assignedDate   = substr($task->assignedDate,   0, 10);
                $task->finishedDate   = substr($task->finishedDate,   0, 10);
                $task->canceledDate   = substr($task->canceledDate,   0, 10);
                $task->closedDate     = substr($task->closedDate,     0, 10);
                $task->lastEditedDate = substr($task->lastEditedDate, 0, 10);
                
            	/* fill cells. */
	            $fields = $this->post->exportFields;
                foreach($fields as $key => $fieldName)
	            {
	                $fieldName = trim($fieldName);
	                $objActiveSheet->setCellValueByColumnAndRow ($key, $row, $task->$fieldName);
	        		unset($fields[$key]);
	        		$col = $key;
	            }
	            /* 对于已关闭的任务，去查该任务的评价并填充
	             * 这里考虑到导出扩展与评价扩展的独立性，若没有安装评价扩展，则不存在评价表及assess.php，
	             * 若直接去查评价表会出错，造成导出功能无法实现，而判断数据库中是否存在评价表不方便，故这里
	             * 判断assess.php中的定义是否存在，作为是否已安装评价插件的标志，若未安装，则不去操作评价列，
	             * 其他列仍然可正常导出
	             */
	            if(isset($this->lang->task->positions))
	            {
		            if($task->status == 'closed' || $task->status == '已关闭')    //若中文已定义则为中文，否则为英文
		            {
						$comments = $this->dao->select('position,dimension,grade')->from('zt_taskcomment')
							->where('task = '.$task->id.' and deleted = "0"')->fetchAll();
						$i = 1;
						foreach($comments as $com)    //填充该任务的评价
						{
							$p = $com->position;
							$pd = $this->lang->task->$p;
							//评价格式为维度中文名与评价等级拼接的字符串
			                $objActiveSheet->setCellValueByColumnAndRow ($col + $i, $row, $pd[$com->dimension].$com->grade);
							$i++;
						}	            	
		            }
	            }
	            $row++;
            }	
			/**********************************************/	
				
			// Redirect output to a clients web browser (Excel5)
			header('Content-Type: application/vnd.ms-excel');			
			header('Content-Disposition: attachment;filename='.$filename.'.xls');
			header('Cache-Control: max-age=0');
			
			$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
			$objWriter->save('php://output');
			//exit;     //加上在IE下点击取消，会弹出保存网页对话框；不加则导出的excel变大
        }
        $this->display();        
    }
}
