<?php
/*
 * @author      Luxiaoping 2013.01.22
 * @package     task
 * @version     v1.0
 * 
 * 扩展task/view/export.html.php视图文件,改写导出选项设置界面，扩展方式为直接覆盖
 */
?>
<?php include '../../../common/view/header.lite.html.php';?>
<?php include '../../../common/view/colorbox.html.php';?>
<?php include '../../../common/view/datepicker.html.php';?>
<?php 
	$taskLang = $this->lang->task; 
    $taskConfig = $this->config->task;
    
    /*获取导出列数组<英文名，中文名>*/
    $fields = explode(',', $taskConfig->exportFields);
    $fieldPairs = Array();
    foreach($fields as $key => $fieldName)
    {
        $fieldName = trim($fieldName);
        $fieldPairs[$fieldName] = isset($taskLang->$fieldName) ? $taskLang->$fieldName : $fieldName;
    }
    
    //默认导出列
    $checkFields = 'id,project,name,deadline,status,estimate,consumed,finishedBy,finishedDate,comment';
    
    //获取用户列表
    $userList = $this->loadModel('user')->getPairs('noletter,noempty,noclosed');
    array_unshift($userList,"所有人");   //在开头插入元素
?>

<script>
function setDownloading()
{
    if($.browser.opera) return true;   // Opera don't support, omit it.

	//提交前验证
	if($('#starttime').val().replace(new RegExp(' ', 'g'),'') == '')
	{
		alert('请输入起始时间！');
		return false;
	}
	if($('#endtime').val().replace(new RegExp(' ', 'g'),'') == '')
	{
		alert('请输入截止时间！');
		return false;
	}

    $.cookie('downloading', 0);
    time = setInterval("closeWindow()", 300);
    return true;
}

function closeWindow()
{
    if($.cookie('downloading') == 1 || i >= 30)
    {
        parent.$.fn.colorbox.close();
        $.cookie('downloading', null);
        clearInterval(time);
    }
    i ++;
}

//调整悬浮框大小、位置
$(function(){
	$('#colorbox', parent.document).height(240);
	$('#cboxWrapper', parent.document).height(300);
	$('#cboxMiddleLeft', parent.document).height(250);
	$('#cboxContent', parent.document).height(250);
	$('#cboxMiddleRight', parent.document).height(250);
	$('#cboxLoadedContent', parent.document).height(300);
	
	$('#colorbox', parent.document).width(540);
	$('#cboxWrapper', parent.document).width(590);
	$('#cboxTopCenter', parent.document).width(540);
	$('#cboxContent', parent.document).width(540);
	$('#cboxLoadedContent', parent.document).width(540);
	$('#cboxBottomCenter', parent.document).width(540);

	var windoww=$(window.parent).width();
	var windowh=$(window.parent).height();
	var thisw=$(window).width();
	var thish=$(window).height();
	$('#colorbox', parent.document).css('top',(windowh-thish)/2);
	$('#colorbox', parent.document).css('left',(windoww-thisw)/2);
	
});
</script>

<style type="text/css">
	.a-left span {white-space: nowrap; display:-moz-inline-box; display:inline-block; width:100px;  }
	.text {padding-left: 15px; }
	.time {width: 80px;}
	div.dp-popup {margin-left: 30px; }
</style> 

<form method='post' target='hiddenwin' onsubmit='return setDownloading();'>
  <table class='table-1'>
    <caption><?php echo $lang->export;?></caption>
    <tr>
      <td class='a-left'>
          导出时间: <?php echo html::input('starttime', date('Y-m-01'), "class='time date'");?>
          至 <?php echo html::input('endtime', date('Y-m-d'), "class='time date'");?>
          <label class="text"></label>
         <?php echo html::select('user', $userList, $this->session->user->account);?>
          <label class="text"></label>
         <?php echo html::submitButton();?>
      </td>
    </tr>
    <tr>
      <td class='a-left'>        
          导出列：
      </td>
    </tr>
    <tr>
      <td class='a-left'>        
        <?php echo html::checkbox('exportFields', $fieldPairs, $checkFields);?> 
      </td>
    </tr>
  </table>
</form>

<?php include '../../../common/view/footer.lite.html.php';?>
